/* @(#)getargs.h             2.0 (Inge Berge Kristiansen) 3/9/85   */
/*
 * Command line argument processor for C programs. All types and
 * defines needed for the getargs() routine.
 */


/*
 * Command line argument types.
 */

# define GA_BOOLEAN  0
# define GA_INT      1
# define GA_CHAR     2
# define GA_STRING   3
# define GA_PROC     4
# define GA_COPY     5
# define GA_HELP     6

/*
 * Command line argument types modifiers.
 */

# define GA_TYPE     0377
# define GA_SPACE    0100000
# define GA_HIDE     0040000
# define GA_NAVAIL   0020000
# define GA_NOMENU   0010000

/*
 * Command table header declaration.
 */

typedef struct {
         char       *ga_ht1;
         char       *ga_ht2;
         char        ga_hor;
         char        ga_ver;
         int       (*ga_error)();
         char      **ga_noarg;
         char      **ga_notavail;
         char      **ga_helpfile;
} GA_HEAD;

/*
 * Command table argument declaration.
 */

typedef struct {
         char        ga_arg;
         char       *ga_text;
         short       ga_type;
         int        *ga_variable;
         char       *ga_errmsg;
} GA_ARG;
