/*@(#)cparameters.c	1.2.1.3          2/9/90*/
/*
 * Creation 1986 by Inge B. Kristiansen.
 * xx.05.90 kk  Version 2 of NC/RPC
 * 30.05.90 kk  removed generation of line "_rp = &_bp[RET...."
 *              removed include BSDdefs.h
 * 04.12.90 kk  removed generation of line "_rp = &_bp[RET...."
 *              in gen_results()
 * 15.12.90 kk  Added generation of special function _dfptr() in case of
 *              passind doubles by reference.
 *              We will generate now _fptr() in any case because it seems to
 *              be necessary on all supported architectures now.
 *              (commented out ifdefs)
 */

#include "sysconfig.h"
#include "np.h"


/*
 * Generate the reference information. This must be done by a separate
 * procedure because floats are passed in register on most machines.
 * (and therefore cannot be referenced)
 */

char *
gen_ref( type, address_mode )
	struct object *type;
	enum addr address_mode;
{
/*
#if (defined(APOLLO) || defined(APOLLO10K) || defined(XENIX) || defined(MIPSULTRIX))
*/
	char *cp;

	cp = refamode( type, address_mode );
	if( (type->t_id == T_FLOATING) && (*cp == '&') ) {
		return( "_fptr" );
	} else {
		return( cp );
	}

#if (defined(APOLLO10K) || defined(MIPSULTRIX))
	if( (type->t_id == T_LONG_FLOATING) && (*cp == '&') ) {
		return( "_dfptr" );
	} else {
		return( cp );
	}
#endif
/*
#else
	return( refamode( type, address_mode ) );
#endif	
*/
}


/*
 * Generate a type conversion if this is necessary. This procedure
 * is called after an argument or a return value is built by the
 * parser. All type conversions should be included here.
 */

struct object *
type_conv( type )
	struct object *type;
{
	/* For the moment there are no type conversions.                */
	return( type );
}


/*
 * Externalize the parameters to the network.
 */

gen_externalize( type, pcondition )
	struct object *type;
	enum parcondition pcondition; 
{
	list p, q;
	struct object *t;
	char *ref;

	for (p = type->t_args; p != NIL; p = cdr(p)) {
		q = car(car(p));
		/* a_mode = genamode(ocar(q)->o_cmod, ocar(q)->o_addr); */
		/* d_mode = gendmode(ocar(q)->o_cmod, ocar(q)->o_dir); */
		t = ocdr(car(p));
		/* ref = refstr(basetype(t)); */
		ref = gen_ref(basetype(t), ocar(q)->o_addr);
		if ((pcondition == P_NP_ALL) || (ocar(q)->o_dir != D_OUT)) {
			for (q = car(car(p)); q != NIL; q = cdr(q)) {
				fprintf(client, "\t_bp += %s(%s(%s), _bp);\n",
					xfn(EXTERNALIZE, t),
					ref, ocar(q)->o_name);
			}
		}
	}
}


/*
 * Internalize the results from the network, if any.
 */

gen_results( type, nresults, result_type, result_name )
	struct object *type;
	int nresults;
	struct object *result_type;
	char *result_name;
{
	list q;

	if (nresults) {
		q = car(car(type->t_results));
		/* a_mode = genamode(ocar(q)->o_cmod, ocar(q)->o_addr); */
		/* d_mode = gendmode(ocar(q)->o_cmod, ocar(q)->o_dir); */
		fprintf(client,
"\t_rp += %s(%s%s, _rp);\n",
			xfn(INTERNALIZE, result_type),
			refstr(basetype(result_type)),
			result_name);
	}
}


/*
 * Generate code to internalize the OUT arguments.
 */

gen_internalize( type, pcondition )
	struct object *type;
	enum parcondition pcondition;
{
	list p, q;
	struct object *t;
	char *ref;

	for (p = type->t_args; p != NIL; p = cdr(p)) {
		q = car(car(p));
		/* a_mode = genamode(ocar(q)->o_cmod, ocar(q)->o_addr); */
		/* d_mode = gendmode(ocar(q)->o_cmod, ocar(q)->o_dir); */
		t = ocdr(car(p));
		/* ref = refstr(basetype(t)); */
		ref = gen_ref(basetype(t), ocar(q)->o_addr);
		if ((pcondition == P_NP_ALL) || (ocar(q)->o_dir != D_IN)) {
			for (q = car(car(p)); q != NIL; q = cdr(q)) {
				fprintf(client, "\t_rp += %s(%s(%s), _rp);\n",
					xfn(INTERNALIZE, t),
					ref, ocar(q)->o_name);
			}
		}
		if (pcondition == P_CHECK && notref(basetype(t), ocar(q)->o_addr))
		    error(WARNING, "in C return parameters should be by reference");

	}
}


/*
 * Internalize the results from the network in case of message.
 */

gen_mesresults( type, nresults, result_type, result_name )
	struct object *type;
	int nresults;
	struct object *result_type;
	char *result_name;
{
	list q;

	if (nresults) {
		q = car(car(type->t_results));
		/* a_mode = genamode(ocar(q)->o_cmod, ocar(q)->o_addr); */
		/* d_mode = gendmode(ocar(q)->o_cmod, ocar(q)->o_dir); */
		fprintf(client,
"\t_rp = _bp;\n\
\t_rp += %s(%s%s, _rp);\n",
			xfn(INTERNALIZE, result_type),
			refstr(basetype(result_type)),
			result_name);
	} else {
		fprintf(client,
"\t_rp = _bp;\n"
			);
	}
}

/*
 * Externalize the parameters in case of memory access.
 */

gen_memexternalize( type, pcondition )
	struct object *type;
	enum parcondition pcondition; 
{
	list p, q;
	struct object *t;
	char *ref;

	for (p = cdr(type->t_args); p != NIL; p = cdr(p)) {
		q = car(car(p));
		/* a_mode = genamode(ocar(q)->o_cmod, ocar(q)->o_addr); */
		/* d_mode = gendmode(ocar(q)->o_cmod, ocar(q)->o_dir); */
		t = ocdr(car(p));
		/* ref = refstr(basetype(t)); */
		ref = gen_ref(basetype(t), ocar(q)->o_addr);
		if ((pcondition == P_NP_ALL) || (ocar(q)->o_dir != D_OUT)) {
			for (q = car(car(p)); q != NIL; q = cdr(q)) {
				fprintf(client, "\t_bp += %s(%s(%s), _bp);\n",
					xfn(EXTERNALIZE, t),
					ref, ocar(q)->o_name);
			}
		}
	}
}


/*
 * Generate code to internalize the result in case of a memory access.
 */

gen_memresults( type, nresults, result_type, result_name )
	struct object *type;
	int nresults;
	struct object *result_type;
	char *result_name;
{
	list q;

	if (nresults) {
		q = car(car(type->t_results));
		/* a_mode = genamode(ocar(q)->o_cmod, ocar(q)->o_addr); */
		/* d_mode = gendmode(ocar(q)->o_cmod, ocar(q)->o_dir); */
		fprintf(client,
"\t_rp += %s(%s%s, _rp);\n",
			xfn(INTERNALIZE, result_type),
			refstr(basetype(result_type)),
			result_name);
	}
}


/*
 * Generate code to internalize the OUT arguments in case of a memory
 * access. 
 */

gen_meminternalize( type, pcondition )
	struct object *type;
	enum parcondition pcondition;
{
	list p, q;
	struct object *t;
	char *ref;

	for (p = cdr(type->t_args); p != NIL; p = cdr(p)) {
		q = car(car(p));
		/* a_mode = genamode(ocar(q)->o_cmod, ocar(q)->o_addr); */
		/* d_mode = gendmode(ocar(q)->o_cmod, ocar(q)->o_dir); */
		t = ocdr(car(p));
		/* ref = refstr(basetype(t)); */
		ref = gen_ref(basetype(t), ocar(q)->o_addr);
		if ((pcondition == P_NP_ALL) || (ocar(q)->o_dir != D_IN)) {
			for (q = car(car(p)); q != NIL; q = cdr(q)) {
				fprintf(client, "\t_rp += %s(%s(%s), _rp);\n",
					xfn(INTERNALIZE, t),
					ref, ocar(q)->o_name);
			}
		}
	}
}
