/*@(#)predef.c	1.2.1.2          6/9/89*/
/*
 * Creation 1986 by Inge B. Kristiansen.
 */
/*
 * 09-06-89 (vfr) size of medium changed to size of long (instead of int)
 */

#include "sysconfig.h"
#include "np.h"


/*
 * Predefined types.
 */

struct pretypes *pt[ PT_MAXPREDEF ];            /* Pointers to all types */
struct pretypes pt_normal;                      /* Normal types */
struct object *undefined_constant;              /* Undefined constant */


/*
 * Macro to predefine types.
 */

#define PREDEFINE( t, x, y, id, n ) { \
	t.pt_/**/x/**/_type = make_type(C_PREDEF); \
	t.pt_/**/x/**/_type->t_name = "y"; \
	t.pt_/**/x/**/_type->t_xsize = n; \
	t.pt_/**/x/**/_type->t_id = id; \
}


/*
 * This mess is needed because C doesn't handle initialization of unions.
 */

setup_predefs()
{
	/* Define all the basic type sets in the table.                 */
	pt[ PT_NORMAL ] = &pt_normal;
	pt[ PT_RAW ] = &pt_normal;
	pt[ PT_ALTNORMAL ] = &pt_normal;
	pt[ PT_ALTRAW ] = &pt_normal;

	/* Predefine the structure of all the types.                    */
/*
#if !(defined(XENIX) || defined SCO386UNIX)
#ifndef lint
	PREDEFINE(pt_normal,boolean,boolean, T_BOOLEAN, sizeof(char));
	PREDEFINE(pt_normal,cardinal,cardinal, T_CARDINAL, sizeof(unsigned short));
	PREDEFINE(pt_normal,long_cardinal,long_cardinal, T_LONG_CARDINAL, sizeof(unsigned long));
	PREDEFINE(pt_normal,character,character, T_CHARACTER, sizeof(char));
	PREDEFINE(pt_normal,integer,integer, T_INTEGER, sizeof(short));
	PREDEFINE(pt_normal,long_integer,long_integer, T_LONG_INTEGER, sizeof(long));
	PREDEFINE(pt_normal,floating,floating, T_FLOATING, sizeof(float));
	PREDEFINE(pt_normal,long_floating,long_floating, T_LONG_FLOATING, sizeof(double));
	PREDEFINE(pt_normal,string,string, T_STRING, -1);
	PREDEFINE(pt_normal,unspecified,unspecified, T_UNSPECIFIED, sizeof(unsigned short));
	PREDEFINE(pt_normal,long_unspecified,long_unspecified, T_LONG_UNSPECIFIED, sizeof(unsigned long));
#endif
#else
*/
	boolean_type = make_type(C_PREDEF);
	boolean_type->t_name = "idl_boolean";
	boolean_type->t_id = T_BOOLEAN;
	boolean_type->t_xsize = sizeof(char);

	byte_type = make_type(C_PREDEF);
	byte_type->t_name = "idl_byte";
	byte_type->t_id = T_BYTE;
	byte_type->t_xsize = sizeof(char);

	character_type = make_type(C_PREDEF);
	character_type->t_name = "idl_char";
	character_type->t_id = T_CHARACTER;
	character_type->t_xsize = sizeof(char);

	small_type = make_type(C_PREDEF);
	small_type->t_name = "idl_small_int";
	small_type->t_id = T_SMALL;
	small_type->t_xsize = sizeof(char);

	integer_type = make_type(C_PREDEF);
	integer_type->t_name = "idl_short_int";
	integer_type->t_id = T_INTEGER;
	integer_type->t_xsize = sizeof(short);

	long_integer_type = make_type(C_PREDEF);
	long_integer_type->t_name = "idl_long_int";
	long_integer_type->t_id = T_LONG_INTEGER;
	long_integer_type->t_xsize = sizeof(long);

	hyper_type = make_type(C_PREDEF);
	hyper_type->t_name = "idl_hyper_int";
	hyper_type->t_id = T_HYPER;
	hyper_type->t_xsize = 2 * sizeof(long);

	usmall_type = make_type(C_PREDEF);
	usmall_type->t_name = "idl_usmall_int";
	usmall_type->t_id = T_USMALL;
	usmall_type->t_xsize = sizeof(char);

	cardinal_type = make_type(C_PREDEF);
	cardinal_type->t_name = "idl_ushort_int";
	cardinal_type->t_id = T_CARDINAL;
	cardinal_type->t_xsize = sizeof(unsigned short);

	long_cardinal_type = make_type(C_PREDEF);
	long_cardinal_type->t_name = "idl_ulong_int";
	long_cardinal_type->t_id = T_LONG_CARDINAL;
	long_cardinal_type->t_xsize = sizeof(unsigned long);

	uhyper_type = make_type(C_PREDEF);
	uhyper_type->t_name = "idl_uhyper_int";
	uhyper_type->t_id = T_UHYPER;
	uhyper_type->t_xsize = 2 * sizeof(long);

	floating_type = make_type(C_PREDEF);
	floating_type->t_name = "idl_short_float";
	floating_type->t_id = T_FLOATING;
	floating_type->t_xsize = sizeof(float);

	long_floating_type = make_type(C_PREDEF);
	long_floating_type->t_name = "idl_long_float";
	long_floating_type->t_id = T_LONG_FLOATING;
	long_floating_type->t_xsize = sizeof(double);

	string_type = make_type(C_PREDEF);
	string_type->t_name = "string";
	string_type->t_id = T_STRING;
	string_type->t_xsize = -1;

	string_ref_type = make_type(C_PREDEF);
	string_ref_type->t_name = "string_ref";
	string_ref_type->t_id = T_STRING_REF;
	string_ref_type->t_xsize = -1;

	unspecified_type = make_type(C_PREDEF);
	unspecified_type->t_name = "unspecified";
	unspecified_type->t_id = T_UNSPECIFIED;
	unspecified_type->t_xsize = sizeof(unsigned short);

	long_unspecified_type = make_type(C_PREDEF);
	long_unspecified_type->t_name = "long_unspecified";
	long_unspecified_type->t_id = T_LONG_UNSPECIFIED;
	long_unspecified_type->t_xsize = sizeof(unsigned long);
/*
#endif
*/
	/* Make an undefined constant in the table structure.           */
	undefined_constant = make_symbol("(undefined)");
	declare(&types, undefined_constant, unspecified_type);
	declare(&values, undefined_constant, make_constant(0));
}
