/*
 * Copyright (C) 1986 by Inge B. Kristiansen.
 * All rights reserved.
 */

#include "sysconfig.h"
#include "np.h"


/*
 * Generate the procedure header according to the users specification.
 * everything is in the lists.
 */

gen_phead( f, rtname, ref, prefix, proc_name, suffix, type )
	FILE *f;
	char *rtname, *ref, *prefix, *proc_name, *suffix;
	struct object *type;
{
	struct object *t;
	list p, q;

	fprintf(f,
"\n\
%s %s\n\
%s%s%s(",
		rtname, ref, prefix, proc_name, suffix);
	for (p = type->t_args; p != NIL; p = cdr(p)) {
		for (q = car(car(p)); q != NIL; q = cdr(q)) {
			fprintf(f, "%s", ocar(q)->o_name);
			if (cdr(q) != NIL)
				fprintf(f, ", ");
		}
		if (cdr(p) != NIL)
			fprintf(f, ", ");
	}
	fprintf(f, ")\n");
	for (p = type->t_args; p != NIL; p = cdr(p)) {
		q = car(car(p));
		t = ocdr(car(p));
		ref = indamode(basetype(t), ocar(q)->o_addr);
		for (q = car(car(p)); q != NIL; q = cdr(q))
			fprintf(f, "\t%s %s%s;\n", rep(t), ref, ocar(q)->o_name);
	}
	fprintf(f, "{\n");
}
