/* @(#)rename.c	1.3.1.2        6/15/89 */
/*
 * Rename a file. This function is necessary on Unix System V
 * because no rename is provided. For Berkeley Unix this function
 * is provided.
 * Note for OS-9:
 * The "rename" works only within one directory. Thus the UNIX "mv"
 * will be emulated by a sequence: "copy from to", then "del from".
 * If the "copy" fails, its error code will be returned and no "del" 
 * done. If the "del" fails, a "del to" will be done (to restore 
 * the old state), and the error of the failed "del" will be returned.
 *
 * 14/02/89 raw: added code for OS-9
 * 28/04/89 raw: use "#if defined" constructs
 */

#include "sysconfig.h"


rename( from, to )
	register char *from;
	register char *to;
{
	int status;
	char command[512];

#if defined(OS9)
	strcpy( command, "copy ");
#else
	strcpy( command, "mv ");
#endif /* OS9 */
	strcat( command, from );
	strcat( command, " " );
	strcat( command, to );
	status = system( command );
#if !defined(OS9)
	return( status );
#else
	if(status != 0)
		return( status );

/*
 * Copy was successful. Now delete old file.
 */
	strcpy( command, "del ");
	strcat( command, from );
	status = system( command );
        if(status == 0)
		return( status );    /* All done, return 0 */

/*
 * Delete of old file failed. Restore old state by
 * deleting new file; return error status.
 */
	strcpy( command, "del ");
	strcat( command, to );
	system( command );
	return( status );
#endif /* OS9 */
}
