%{
/*@(#)scanner.l	1.2.1.3          5/11/89*/
/*
 * Creation 1986 by Inge B. Kristiansen.
 *
 * 03/05/89 (phd+vfr) GLOBAL facility
 * 11/05/89 (gm+vfr) $ suppressed to make lex work
 * 12.11.92 kk  added private, sequence_ref, string_ref, autofree
 * 22.01.93 kk  removed medium, added nc_sequence
 */

#include "sysconfig.h"
#include "np.h"
#include "y.tab.h"
%}

%a              7000
%e              2500
%n              2000
%o              7000
%p              7000

%%

--.*\n		;
[ \t\n]		;
ABSOLUTE        { return (ABSOLUTE); }
absolute        { return (ABSOLUTE); }
ADDRESS         { return (ADDRESS); }
address         { return (ADDRESS); }
ARRAY		{ return (ARRAY); }
array		{ return (ARRAY); }
AUTHOR          { return (AUTHOR); }
author          { return (AUTHOR); }
autofree        { return (AUTOFREE); }
AUTOFREE        { return (AUTOFREE); }
BEGIN		{ return (BEGIN_); }
begin		{ return (BEGIN_); }
BINDING         { return (BINDING); }
binding         { return (BINDING); }
BOOLEAN		{ return (BOOLEAN); }
boolean		{ return (BOOLEAN); }
BY              { return (BY); }
by              { return (BY); }
BYTE            { return(BYTE); }
byte            { return(BYTE); }
CARDINAL	{ return (CARDINAL); }
cardinal	{ return (CARDINAL); }
CHAR            { return (CHAR); }
char            { return (CHAR); }
CHOICE		{ return (CHOICE); }
choice		{ return (CHOICE); }
CLIENT          { return (CLIENT); }
client          { return (CLIENT); }
CONNECTION      { return (CONNECTION);}
connection      { return (CONNECTION);}
CONSTANT        { return (CONSTANT);}
constant        { return (CONSTANT);}
DATE            { return (DATE); }
date            { return (DATE); }
DEPENDS		{ return (DEPENDS); }
depends		{ return (DEPENDS); }
DIRECTORY       { return (DIRECTORY); }
directory       { return (DIRECTORY); }
DOUBLE          { return (DOUBLE); }
double          { return (DOUBLE); }
END		{ return (END); }
end		{ return (END); }
ERROR		{ return (ERROR); }
error		{ return (ERROR); }
EXCEPTION       { return (EXCEPTION); }
exception       { return (EXCEPTION); }
EXECUTABLE      { return (EXECUTABLE); }
executable      { return (EXECUTABLE); }
EXECUTION       { return (EXECUTION); }
execution       { return (EXECUTION); }
FLOAT           { return (FLOAT); }
float           { return (FLOAT); }
FILE            { return (FILE_); }
file            { return (FILE_); }
GLOBAL          { return (GLOBAL); }
global          { return (GLOBAL); }
HOST            { return (HOST); }
host            { return (HOST); }
HYPER           { return (HYPER); }
hyper           { return (HYPER); }
IN              { return (IN); }
in              { return (IN); }
INOUT           { return (INOUT); }
inout           { return (INOUT); }
INTEGER		{ return (INTEGER); }
integer		{ return (INTEGER); }
INTERFACE       { return (INTERFACE); }
interface       { return (INTERFACE); }
INTERRUPT       { return (INTERRUPT); }
interrupt       { return (INTERRUPT); }
LOAD            { return (LOAD); }
load            { return (LOAD); }
LONG		{ return (LONG); }
long		{ return (LONG); }
MAXCONNECTIONS  { return (MAXCONNECTIONS); }
maxconnections  { return (MAXCONNECTIONS); }
MEMORY          { return (MEMORY); }
memory          { return (MEMORY); }
MESSAGE         { return (MESSAGE); }
message         { return (MESSAGE); }
MODIFIED        { return (MODIFIED); }
modified        { return (MODIFIED); }
NAME            { return (NAME); }
name            { return (NAME); }
OF		{ return (OF); }
of		{ return (OF); }
OUT             { return (OUT); }
out             { return (OUT); }
PARAMETERS      { return (PARAMETERS); }
parameters      { return (PARAMETERS); }
PERMISSION      { return (PERMISSION); }
permission      { return (PERMISSION); }
POLICY          { return (POLICY); }
policy          { return (POLICY); }
PORT            { return (PORT); }
port            { return (PORT); }
PRIVATE         { return (PRIVATE); }
private         { return (PRIVATE); }
PROCEDURE       { return (PROCEDURE); }
procedure	{ return (PROCEDURE); }
PROGRAM		{ return (PROGRAM); }
program		{ return (PROGRAM); }
PROTECTION      { return (PROTECTION); }
protection      { return (PROTECTION); }
PROTOCOL        { return (PROTOCOL); }
protocol        { return (PROTOCOL); }
RACCESS         { return (READ); }
raccess         { return (READ); }
RECORD		{ return (RECORD); }
record		{ return (RECORD); }
REF             { return (REF); }
ref             { return (REF); }
REGION          { return (REGION); }
region          { return (REGION); }
RELATIVE        { return (RELATIVE); }
relative        { return (RELATIVE); }
RETURNS		{ return (RETURNS); }
returns		{ return (RETURNS); }
SERVER          { return (SERVER); }
server          { return (SERVER); }
SERVICE         { return (SERVICE); }
service         { return (SERVICE); }
SEQUENCE	{ return (SEQUENCE); }
sequence	{ return (SEQUENCE); }
SEQUENCE_REF    { return (SEQUENCE_REF); }
sequence_ref    { return (SEQUENCE_REF); }
NC_SEQUENCE     { return (NC_SEQUENCE); }
nc_sequence     { return (NC_SEQUENCE); }
NC_SEQUENCE_REF { return (NC_SEQUENCE_REF); }
nc_sequence_ref { return (NC_SEQUENCE_REF); }
SHORT           { return (SHORT); }
short           { return (SHORT); }
SMALL           { return (SMALL); }
small           { return (SMALL); }
STATISTICS      { return (STATISTICS); }
statistics      { return (STATISTICS); }
STRING		{ return (STRING); }
string		{ return (STRING); }
STRING_REF      { return (STRING_REF); }
string_ref      { return (STRING_REF); }
TIMEOUT         { return (TIMEOUT); }
timeout         { return (TIMEOUT); }
TYPE		{ return (TYPE); }
type		{ return (TYPE); }
UNSIGNED        { return (UNSIGNED); }
unsigned        { return (UNSIGNED); }
UNSPECIFIED     { return (UNSPECIFIED); }
unspecified	{ return (UNSPECIFIED); }
UPON		{ return (UPON); }
upon		{ return (UPON); }
VALUE           { return (VALUE); }
value           { return (VALUE); }
VERSION		{ return (VERSION); }
version		{ return (VERSION); }
WACCESS         { return (WRITE); }
waccess         { return (WRITE); }

#[ ]+[0-9]+[ ]+\"[ -~]*\" {
				/*
				 * Match the preprocessor lines.
				 */
				make_line_file(yytext);
			}

\"[ -~]*\"              {
				/*
				 * Free text item.
				 */
				yylval.object = make_text(yytext);
				return (atext);
			}

[\-d][\-mnx][\-rw][\-rw]\-[\-rw][\-rw]\-[\-rw][\-rw]\- {
				/*
				 * Permission object.
				 */
				yylval.object = make_constant(make_permission(yytext));
				return (permission);
			}

-?0x[0-9a-fA-F]+        {
				/*
				 * Hexadecimal numbers.
				 */
				char    *yyptr;
				yyptr = yytext;
				yylval.object = make_constant(stoi(&yyptr));
				return (number);
			}

-?0[0-7]*               {
				/*
				 * Octal numbers.
				 */
				char    *yyptr;
				yyptr = yytext;
				yylval.object = make_constant(stoi(&yyptr));
				return (number);
			}

-?[1-9][0-9]*           {
				/*
				 * Decimal numbers.
				 */
				char    *yyptr;
				yyptr = yytext;
				yylval.object = make_constant(stoi(&yyptr));
				return (number);
			}

\'[ -~]\'               {
				/*
				 * Character constant.
				 */
				char    c;
				c = yytext[1];
				yylval.object = make_constant((int)c);
				return (number);
			}

[a-zA-Z_][a-zA-Z0-9_]*  {
				yylval.object = make_symbol(yytext);
				return (identifier);
			}

.			{
				return ((int) yytext[0]);
			}

%%
