/*
 * xx.05.90 kk  Kris Kostro
 * 28.05.90 kk  The constant which uniquely defines the system is specified
 *              in the begin of this file and it is generated by the custom
 *              utility.
 *              The characteristics of the system are specified by specific
 *              defines and are choosen on the base of the unique constant.
 *
 *              The unique definition should not, or only exceptionally,
 *              be used in source files. It should rather be used in this
 *              file to choose the specific defines. To select some system
 *              characteristics (e.g. the brand of memory copy functions)
 *              new defines can be added to this file (e.g. #define BSDcpy
 *              to select BSD brand functions bcopy() etc. or #define SYSVcpy
 *              to select Unix Sys. V brand functions memcpy() etc.).
 * LP - 22.05.2000 - spurios right square bracket deleted in line 412
 *                 - define fixes
 * CS - 05.09.2000 - removed some old targets
 */
#ifndef SYSCONFIG 
#define SYSCONFIG

#define  LINUXAMD64 1
/*
 * CC_DEFAULT only has to be defined if default cc is not enaugh i.e.
 * #define CC_DEFAULT "/bin/cc -g" to make code for debugging
 * CC_DEFAULT is useful for adding flags to cc (eg. debugging or optimisation)
 * The same is true for CPP_DEFAULT
 */

#if defined(LYNX386)
#define LOW_ENDER 1
#define BSDtime 1
#define CC_DEFAULT "/bin/gcc -X -k -D_POSIX_SOURCE"
#define CPP_DEFAULT "/usr/local/lib/gcc-cpp -P -undef"
#define SIGOOB_ENABLE FCTL
#define RANLIB 1
#define LYNX 1
#define NC_SELECT_MS 50

#endif

#if defined(LYNX68K)
#define HIGH_ENDER 1
#define BSDtime 1
#define CC_DEFAULT "/bin/gcc -X -k -D_POSIX_SOURCE"
#define CPP_DEFAULT "/usr/local/lib/gcc-cpp -P -undef"
#define SIGOOB_ENABLE FCTL
#define RANLIB 1
#define LYNX 1
#define _NO_SETPGID_ 1  /* setpgrp() used instead */
#define NC_SELECT_MS 100
#endif

#if defined(LYNXPOW)
#define HIGH_ENDER 1
#define BSDtime 1
#define CC_DEFAULT "/bin/gcc -X -D_POSIX_SOURCE"
#define SIGOOB_ENABLE FCTL
#define LYNX 1
#define _NO_SETPGID_ 1  /* setpgrp() used instead */
#define NC_SELECT_MS 50 
#endif


#if defined(SUNSPARC)
#define MYMAKE_DEFAULT "/usr/ccs/bin/make"
#define CC_DEFAULT "/usr/ucb/cc"
#define CPP_DEFAULT "/usr/ccs/lib/cpp"
#define HIGH_ENDER 1
#define BSDtime 1
#define BSDwait 1
#define BSDsignal 1
#define SIGOOB_ENABLE FCTL
#define RANLIB 1
#endif


#if defined(HPPA)
#define CPP_DEFAULT "/usr/ccs/lbin/cpp -P"
#define HIGH_ENDER 1
#define _POSIX_SOURCE 1
#define BSDtime 1 /* C.S. 5 mar 2001*/
#define POSIXsignal 1
#define POSIXwait 1
#define HPUX 1
#define NC_SELECT_MS 20
#define RX_USER 1
/*#define DEBUG 1*/
#endif


#if defined(OS9)
#define CC_DEFAULT "cc -mode=c89"
/* has to be absolute path */
#define HIGH_ENDER 1
#define OS9time 1
#define SYSVsignal 1
#define BSDstrlib 1
#define _NO_TIMEVAL_DEF_ 1
#define _NO_ITIMERVAL_DEF_ 1
#define _NO_SETPGID_ 1
#define _NO_ATEXIT 1
#define NC_FORK_REVERSE 1
#define LIB_SOCK -l=netdb.l -l=socklib.l -l=sys_clib.l -l=math.l
#endif

#if defined(LINUX386)
#define LOW_ENDER 1
#define CPP_DEFAULT "/lib/cpp -P"
#define BSDtime 1
#define BSDsignal 1
#define BSDwait 1
#define NC_SELECT_MS 20
#define RX_USER 1
#endif

#if defined(LINUXAMD64)
#define LOW_ENDER 1
#define CPP_DEFAULT "/lib/cpp -P"
#define BSDtime 1
#define BSDsignal 1
#define BSDwait 1
#define NC_SELECT_MS 20
#define RX_USER 1
#define _POSIX_SOURCE 1
#endif

#if defined(LINUXPPC)
#define HIGH_ENDER 1
#define CPP_DEFAULT "/lib/cpp -P"
#define BSDtime 1
#define BSDsignal 1
#define BSDwait 1
#define NC_SELECT_MS 20
#define RX_USER 1
#endif

#if defined(LINUXARM)
#define LOW_ENDER 1
#define CPP_DEFAULT "/lib/cpp -P"
#define BSDtime 1
#define BSDsignal 1
#define BSDwait 1
#define NC_SELECT_MS 20
#define RX_USER 1
#define _POSIX_SOURCE 1
#endif

/* NC version and revision */
#define NC_VERSION      2
#define NC_REVISION     14

/* defaults for definitions */

/* byteorder and float definitions. */
#define NC_BO_M6800     1       /* byteorder like Motorola */
#define NC_BO_I386      2       /* byteorder like INTEL */

#define NC_FT_IEEE      1       /* IEEE floating format */
#define NC_FT_VAX       5       /* VAX floating format */


#if defined(LOW_ENDER)
#define NC_BYTEORDER    NC_BO_I386
#endif
#if defined(HIGH_ENDER)
#define NC_BYTEORDER    NC_BO_M6800
#endif

#if defined(VAX)
#define NC_FLOATTYPE    NC_FT_VAX
#else
#define NC_FLOATTYPE    NC_FT_IEEE
#endif

/* Confusion on int and long starts to appear with 64-bit processors */
#if defined(ALPHAOSF) || defined (LINUXAMD64)
#define nc_32int int
#define nc_32uint unsigned int
#define nc_64int long
#define nc_64uint unsigned long
#else
#define nc_32int long
#define nc_32uint unsigned long
#endif


#endif /* SYSCONFIG */
