/*
 * Copyright (C) 1986 by Inge B. Kristiansen.
 * All rights reserved.
 */

#include "sysconfig.h"
#include "ncc.h"
#include "nc.h"


/*
 * Some compilers handle float's transfered by value wrong. This is the
 * case for XENIX and AEGIS, and this procedure will correct it.
 *
 * XENIX:  Pushes the float directly into the floating point coprocessor
 *         internal stack. Nothing is on the runtime stack in memory.
 *
 * AEGIS:  Converts the float to a double before it is pushed onto the
 *         runtime stack.
 *
 * 05.12.90 kk  added similar treatment for double floats. Note that the
 *              problem is not a "wrong treatment" but the fact that you
 *              cannot derefference register variables !!!!
 *
 */

float *
_fptr(fl)
float fl;
{
	static float f;

	/* Copy the float into static memory and return its address.    */
	f = fl;
	return( &f );
}
	
#if (defined(APOLLO10K) || defined(MIPSULTRIX))
double * _dfptr( double dfl )
{
	static double df;

	/* Copy the float into static memory and return its address.    */
	df = dfl;
	return( &df );
}
#endif
