/*
 *
 * xx.05.90 kk  Version 2.0
 * 10.05.90 kk  added byteorder and floattype. There should be a common file
 *              for global variables
 * 07.09.90 kk  file name changed to global.c. Added nc_select_mask.
 * TG           merged rx.c and global.c for VMS compiler
 */

#include "sysconfig.h"
#include "ncc.h"
#include "nc.h"


/*
 * Version and revision global variables to be used in the RPX protocol
 * headers.
 */

char    nc_version = NC_VERSION;                /* Version number */
char    nc_revision = NC_REVISION;              /* Revision number */

/*
 * Global variables defining byte order and float type
 */

char nc_byteorder = NC_BYTEORDER;
char nc_floattype = NC_FLOATTYPE;

struct nctrace nctrace = {0};

char * ncerrstring = 0;         /* to deallocate error strings at next error */
/*
 * nc_select_mask is the mask of all file descriptors using network for nc
 * It should be updated every time a socket descriptor is opened or closed
 */
/* We could use FD_SET on systems which have it implemented */

unsigned long nc_select_mask = 0;


protocol p_null = {                     /* NULL protocol block */
	0,                              /* Flags */
	"NC_P_NULL",                    /* Name */
	{ 0, 0, 0, 0, 0 },              /* Unused area */
	nc_pdummy,                      /* p_socket */
	nc_pdummy,                      /* p_select */
	nc_pdummy,                      /* p_open */
	nc_pdummy,                      /* p_iocntl */
	nc_pdummy,                      /* p_write */
	nc_pdummy,                      /* p_read */
	nc_pdummy,                      /* p_flush */
	nc_pdummy,                      /* p_close */
	nc_pdummy,                      /* p_kill */
	nc_pdummy,                      /* p_abort */
	nc_pdummy,                      /* p_cleanup */
	nc_pdummy,                      /* p_getclid */
};

/*
 * Set up protocol handling routines for NC_P_RX
 * rx does not use the interface defined by Inge Kristiansen but, to fool
 * the linker we call it through the same table.
 */

protocol p_rx = {                       /* RX protocol block */
	NC_P_FCLIENT | NC_P_FSERVER,    /* Flags */
	"NC_P_RX",                      /* Name */
	{ 0, 0, 0, 0, 0 },              /* Unused area */
	nc_pdummy,                      /* p_socket */
	nc_pdummy,                      /* p_select */
	nc_pdummy,                      /* p_open */
	nc_pdummy,                      /* p_iocntl */
	nc_pdummy,                      /* p_write */
	nc_pdummy,                      /* p_read */
	nc_pdummy,                      /* p_flush */
	nc_pdummy,                      /* p_close */
	nc_pdummy,                      /* p_kill */
	nc_pdummy,                      /* p_abort */
	rx_garbage_collect,             /* p_cleanup */
	nc_pdummy,                      /* p_getclid */
};

/*
 * Dummy procedure to be called when the corresponding protocol routine
 * is not available in the transport protocol. It will always return
 * zero.
 */

int
nc_pdummy(void)
{
	/* Return an Ok status always.					*/
	return( 0 );
}
/*
 * define a dummy function to force the inclusion of these fields
 */

int
nc_dglobal(void)
{
	return(0);
}

