/*
 * 07.09.93 kk  added nc_tracefile() to send stderr to a file
 * 10.07.90 kk  Created by Kris Kostro
 * CS - 11.09.2000 clenup version - obsolete #ifedf removed
*/

#include "sysconfig.h"
#if !defined(NO_STDLIB_H)
#include <stdlib.h>
#endif
#include "ncc.h"
#include "nc.h"

#ifndef OS9
#include <time.h>
#endif
extern nct_service     nc_service[NC_MAXSERVICES];

void
nc_trace(char *flag_string)
{
	register char *cp;
	struct nctrace *trace;
	int i;
	register nct_cservice *cd;

	trace = &nctrace;
	trace->tron = trace->calls = trace->data = trace->callmsg =
		      trace->retmsg = trace->sockets = trace->serviceid =
		      trace->exceptions = 0;
	if ((flag_string != (char *)0) && (flag_string != "\0")) {
		trace->tron = 1;
		for (cp = flag_string; *cp != 0; cp += 1) {
			switch (*cp) {
			    case '?':
				printf("nc trace options:\n\
a\tallocation\n\
d\tdata\n\
c\tcalls\n\
m\tcall messages\n\
r\treturn messages\n\
s\tsockets\n\
i\tservice identifiers\n\
x\texceptions\n\
z\tdump service info\n\
\tempty string will switch off trace\n");
				break;
			    case 'a':
				trace->allocation = 1;
				break;
			    case 'd':
				trace->data = 1;
				break;
			    case 'c':
				trace->calls = 1;
				break;
			    case 'm':
				trace->callmsg = 1;
				break;
			    case 'r':
				trace->retmsg = 1;
				break;
			    case 's':
				trace->sockets = 1;
				break;
			    case 'i':
				trace->serviceid = 1;
				break;
			    case 'e':
				trace->exceptions = 1;
				break;
			    case 'z':
				/* print nc service info */
				for( i = 0; i < NC_MAXSERVICES; ++i ) {
					if( nc_service[i].nc_servicetype != NC_FREE ) {
						fprintf(stderr, "%d type %d ", i, nc_service[i].nc_servicetype);
						if( (cd = nc_service[i].nc_cservice) == 0 ) {
							fprintf(stderr, "no service descriptor!\n");
							continue;
						}
#if !(defined(OS9))
						fprintf(stderr, "%s to %s.%d tmo %ld at %s", cd->ncc_name,
							cd->ncc_hostname, cd->ncc_port, cd->ncc_noresponse, ctime((time_t *)&(cd->ncc_time)));
#else
						fprintf(stderr, "%s to %s.%d tmo %ld", cd->ncc_name,
							cd->ncc_hostname, cd->ncc_port, cd->ncc_noresponse);
#endif
					}
				}
				break;
			    default:
				break;
			}
		}
	}
}


void
nc_tracefile(char *file_string)
{
FILE *tracef;                   /* points to the trace file together with stderr */
	if (fclose(stderr) == -1) {
		perror("fclose()");
		return;
	}
	/* tracef should point to the same file a s stderr */
	if ((tracef = fopen(file_string, "w")) == NULL) {
		printf("Cannot open trace file %s\n", file_string);
		return;
	}
	setbuf(tracef,(char *)0);
	printf("stderr is on file %s\n", file_string);
}
