/*
 * 12.03.91 K. Kostro for version 2.3
 * 11.09.2000 - CS clean up version
 */

#include "sysconfig.h"
#include "errtype.h"
#include "ncc.h"
#include "nc.h"


/*
 * Set timeout for all subsequent calls. It would be better to have a timeout
 * per call but this would require change of the compiler.
 */

unsigned long
nc_calltmo(int service_entry_id, long unsigned int timeout)
	                     
	                                /* in milliseconds */
{
	register nct_cservice *cd;
	unsigned long oldtmo;

	/* Get a pointer to the connection descriptor.                  */
	if( (service_entry_id < 0) || ((cd = nc_sgetptr( service_entry_id )) == 0) ) {
		RETURNERR( ENCNOSERVICE, ETNCRT, "nc_sgetptr()" );
	}
	oldtmo = cd->ncc_noresponse;
	cd->ncc_noresponse = timeout;
	return(oldtmo);
}


/*
 * Set call flags for all subsequent calls. It would be better to have it
 * per call but this would require change of the compiler.
 * Effective only with the RX protocol.
 */

unsigned
nc_callflags(int service_entry_id, unsigned int flags)
	                     
	                        /* RX call flags i.e for broadcast calls */
{
	register nct_cservice *cd;
	unsigned oldflags;

	/* Get a pointer to the connection descriptor.                  */
	if( (service_entry_id < 0) || ((cd = nc_sgetptr( service_entry_id )) == 0) ) {
		RETURNERR( ENCNOSERVICE, ETNCRT, "nc_sgetptr()" );
	}
	oldflags = cd->ncc_callflags;
	cd->ncc_callflags = flags;
	return(oldflags);
}


unsigned short
nc_getrxport(void)
{
	int sd;
	unsigned short port;
	rx_getsockport(&sd, &port);
	return(port);
}
