/*
 * Copyright (C) 1986 by CERN.
 *
 * 19.05.90     First written by Kris Kostro (nc version 2)
 * C.S. 29 dec. 2000: added return value for int declared functions
 */

#include "sysconfig.h"
#include "errtype.h"
#include "ncc.h"
#include "nc.h"

/*
 * User library interface routines to get information about the last call.
 */


extern struct ncct_call_header nc_lastcallh;
extern nct_cservice *nc_lastcd;


int
nc_getcalladdr(long unsigned int *host, short unsigned int *port)
{
	protocol *p;

	/*
	 * Get the ip address and port origin of the last call or message.
	 * Addresses are in net order.
	 */
	p = nc_lastcd->ncc_protocol;
	if (p == NC_P_RX) {
		*host = nc_lastcd->ncc_cd.host;
		*port = nc_lastcd->ncc_cd.port;
	} else {
		if ((*p->p_getaddr)(nc_lastcd->ncc_connection, host, port) < 0)
			return(-1);
	}
	return(0);
}


int
nc_getuidgid(short unsigned int *uid, short unsigned int *gid)
{
	/*
	 * Get the uid, gid of the last call or message.
	 */
	*uid = nc_lastcallh.ncc_userid;
	*gid = nc_lastcallh.ncc_groupid;
	return(0); /*C.S. 29 dec. 2000 */
}


int
nc_getcallorder(unsigned char *byteorder, unsigned char *floattype)
{
	/*
	 * Get the byteorder and floattype of the last call or message.
	 */
	*byteorder = nc_lastcallh.ncc_byteorder;
	*floattype = nc_lastcallh.ncc_floattype;
	return(0); /*C.S. 29 dec. 2000 */
}
