/*
 * Copyright (C) 1986 by Inge B. Kristiansen.
 * All rights reserved.
 */

#include "sysconfig.h"
#include "errtype.h"
#include "ncc.h"
#include "nc.h"


/*
 * Perform the permission check before calling a remote procedure.
 */

int
nc_permission(struct ncct_call_header *ncc_ihead, struct nct_cservice *cd, int proc_number)
{
	unsigned short pperm, sperm;
	int shift;

	/* Find out which permission to apply - user, group or other.   */
	if( ncc_ihead->ncc_userid == cd->ncc_uid ) {
		shift = 6;
	} else if( ncc_ihead->ncc_groupid == cd->ncc_gid ) {
		shift = 3;
	} else {
		shift = 0;
	}

	/* Get the permission for the procedure.                        */
	pperm = cd->ncc_permissions[proc_number];

	/* Get the permission for the server as a whole.                */
	sperm = (cd->ncc_flags >> shift) & 07;

	/* Check the permission by logical AND.                         */
	if( sperm & pperm ) {
		return( 0 );
	} else {
		RETURNERR(ENCCACCES, ETNCRT, "no permission to execute")
	}
}
