/*
 * 04.07.90     Written by Kris Kostro
 * 11.09.2000 - CS cleanup version, removed obsolete #ifdef
 */

#include "sysconfig.h"
#if !defined(NO_STDLIB_H)
#include <stdlib.h>
#endif
#if defined(LYNX2_2_1)
#include <oscalls.h>
#endif
#include <string.h>
#ifdef OS9
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <signal.h>

#include "errtype.h"
#include "ncc.h"
#include "nc.h"

extern int nc_exit_srv;

idl_short_int
util(code)
idl_long_int code;
{
#if defined(_POSIX_SOURCE)
  pid_t pid;
#else
  int pid;
#endif

switch (code) {
    case NCR_ARE_YOU_OK:
	break;
    case NCR_EXIT:
/* It's safer not to check uid/gid because otherwise the process will
   not be terminated if setuid/gid did not work
	{
		unsigned short uid, gid, ruid, rgid;
#ifdef OS9
		int giduid;
#endif
		if (nc_getuidgid(&ruid, &rgid) < 0)
			return(-1);
#ifdef OS9
		giduid=getuid();
		uid = 0xffff & giduid;
		gid = giduid >> 16;
#else
		uid = getuid();
		gid = getgid();
#endif
		if( uid != ruid || gid != rgid)
			RETURNERR(ENCCACCES, ETNCRT, "local/remote uid gid conflict")
	}
*/
	nc_exit_srv = NC_EX_NOW;
	break;
    default:
	break;
}
return(0);
}


idl_short_int
newserv(whenexit)
idl_long_int whenexit;
{
	extern struct ncct_call_header nc_lastcallh;
	extern nct_cservice *nc_lastcd;
	extern int nc_ex_spawned;
	extern int nc_exit_srv;
	extern int nc_os9fork;
	extern int nc_setpgid;  /* allows disabling of setpgid for detached servers */
	extern int nc_fork_reverse; /* switch for two types of parentship */
	unsigned short ruid, rgid;
	int pid, old_pid;
	unsigned short port = 0;
#if defined(OS9)
	int giduid;
#endif

	if (nc_getuidgid(&ruid, &rgid) < 0)
		return(-1);
#if !(defined(OS9))
	/* verify whether server can run in detached mode */
	if ((nc_lastcd->ncc_execution == NC_EX_ANY) ||
			(nc_lastcd->ncc_execution == NC_EX_DETACH)) {
	    if (nc_fork_reverse) {
		/*
		 * for the time being we detach the spawned process by letting the
		 * child to continue on the current port and the parent opening
		 * a new port.
		 */
		if (rx_newsd(&port) < 0)
			return(-1);
		TRACE(sockets && printf("newserv() allocated new rx port %d\n", port));
		old_pid = getpid ();
		if ((pid = rx_fork()) < 0) {       /* cannot fork */
			return(-1);
		} else if (pid == 0) {          /* child */
#if !defined(_NO_SETPGID_)
		    if (nc_setpgid)
			setpgid(0, getpid());
#endif
#if defined(LYNX)
		    if (nc_setpgid)
			setpgrp(0, getpid());
#endif
			/*
			 * In child we continue to process requests on
			 * the well-defined server port.
			 */
		        
			/* Clear statistics */
			memset((void*)&nc_statistics, 0, sizeof(nc_statistics_t));

			return(port);
		}
		/* set the exit condition for nc_serverloop */
		nc_ex_spawned = 1;
		if (whenexit != NC_EX_NULL)
			nc_exit_srv = whenexit;
		/*
		   Parent closed the current rx port and assigned the new port.
		   To avoid the reply to the client we set the nc message type
		   to NCC_MESSAGE.
		 */
		/* Update the statistics variable */
		nc_statistics.forks++;


		/* we apply some insider knowledge here */
		nc_lastcallh.ncc_type = NCC_NOREPLY;        /* this avoids server reply */
		if (nc_lastcd->ncc_protection != NC_PR_PUBLIC) {
			if  (ruid == 0)
				RETURNERR(ENCCPROTECTION, ETNCRT, "cannot set to su");
			/* try to set the uid/gid to the caller's one */
			if ( setgid(rgid) || setuid(ruid)) {
				/* exit after return */
				nc_exit_srv = NC_EX_ONFORK;
				RETURNERR(ENCCPROTECTION, ETNCRT, "setuid()");
			}
		}
		return(0);
	    } else {
		/* normal fork - child is using a new port */
		if (rx_newsd(&port) < 0)
			return(-1);
		TRACE(sockets && printf("newserv() allocated new rx port %d\n", port));
		old_pid = getpid ();
		if ((pid = rx_fork_norm()) < 0) {       /* cannot fork */
			return(-1);
		} else if (pid == 0) {          /* child */
#if !defined(_NO_SETPGID_)
		    if (nc_setpgid)
			setpgid(0, getpid());
#endif
#if defined(LYNX)
		    if (nc_setpgid)
			setpgrp(0, getpid());
#endif
			/*
			 * In child we serve the new client
			 */
#if defined(SIGCHLD)
			signal(SIGCHLD, SIG_DFL);
#else
			signal(SIGCLD, SIG_DFL);
#endif
			/* Clear statistics */
			memset((void*)&nc_statistics, 0, sizeof(nc_statistics_t));
			/* set the exit condition for nc_serverloop */
			nc_ex_spawned = 1;
			if (whenexit != NC_EX_NULL)
				nc_exit_srv = whenexit;
			/*
			   Parent closed the current rx port and assigned the new port.
			   To avoid the reply to the client we set the nc message type
			   to NCC_MESSAGE.
			 */
			/* Update the statistics variable */
			nc_statistics.forks++;
			
			/* we apply some insider knowledge here */
			nc_lastcallh.ncc_type = NCC_NOREPLY;        /* this avoids server reply */
			if (nc_lastcd->ncc_protection != NC_PR_PUBLIC) {
				if  (ruid == 0)
					RETURNERR(ENCCPROTECTION, ETNCRT, "cannot set to su");
				/* try to set the uid/gid to the caller's one */
				if ( setgid(rgid) || setuid(ruid)) {
					/* exit after return */
					nc_exit_srv = NC_EX_ONFORK;
					RETURNERR(ENCCPROTECTION, ETNCRT, "setuid()");
				}
			}
			return(0);
		}
		/* father returns the new port */
		return(port);
	    }
	} else {
		/* return permission denied */
		RETURNERR(ENCCEXECUTION, ETNCRT, "fork not allowed")
	}

#else /* OS9  */
#if defined(OS9)
	/* verify whether server can run in detached mode */
	if ((nc_lastcd->ncc_execution == NC_EX_ANY) ||
			(nc_lastcd->ncc_execution == NC_EX_DETACH)) {
		/*
		 * for OS9 we let the process to continue on the new port
		 * but he actual os9exec will be done in serverloop()
		 */
		if (rx_newsd(&port) < 0)
			return(-1);
		TRACE(sockets && printf("newserv() allocated new rx port %d\n", port));
		/* set the exit condition for nc_serverloop */
		nc_exit_srv = whenexit;
		nc_ex_spawned = 1;
		if (nc_lastcd->ncc_protection == NC_PR_PRIVATE) {
			/* try to set the uid/gid to the caller's one */
			/* OS-9 has a different representation of group- */
			/* and user-ID than UNIX.                        */
			if (setuid((rgid << 16) | ruid))
				RETURNERR(errno, ETOS9, "setuid()");
		}
		nc_os9fork = 1; /* tell serverloop() that it should fork */

		/* Update the statistics variable */
		nc_statistics.forks++;

		/* clear errno just for case there was error on setuid/gid */
		errno = 0;
		return(port);
	} else {
		/* return permission denied */
		RETURNERR(ENCCACCES, ETNCRT, "");
	}
#endif /* OS9 */
#endif
}


void
freeserv(code)
idl_long_int code;
{
	extern nct_cservice *nc_lastcd;

switch (code) {
    case NCR_EXIT:
/* It's safer not to check uid/gid because otherwise the process will
   not be terminated if setuid/gid did not work
	{
		unsigned short uid, gid, ruid, rgid;
#ifdef OS9
		int giduid;
#endif
		if (nc_getuidgid(&ruid, &rgid) < 0)
			return(-1);
#ifdef OS9
		giduid=getuid();
		uid = 0xffff & giduid;
		gid = giduid >> 16;
#else
		uid = getuid();
		gid = getgid();
#endif
		if( uid != ruid || gid != rgid)
			RETURNERR(ENCCACCES, ETNCRT, "local/remote uid gid conflict")
	}
*/
	nc_exit_srv = NC_EX_NOW;
	break;
    default:
	break;
}
}


idl_long_int nc_stat (which, stats)
     idl_long_int which;
     nc_statistics_t *stats;

{
  memcpy(stats, &nc_statistics, sizeof(nc_statistics_t));
  return (0);
}

void stat_req (which, dummy, port)
     idl_long_int which;
     idl_short_int dummy;
     unsigned short port;

{
      if (which == 0)
	{
	  memset ((void *) &nc_statistics, 0, sizeof (nc_statistics_t));
	}
      return;
}
