/*
 * rx_more() allows streamed read
 * CS - 07.09.2000 : general heavy clenaup
 *                   removed all old dead code: RX_KERNEL etc...
 */

#include "allincl.h"

int

rx_more(struct rx_call_descr *cd)
{
	/*
	   This call reads reminder of the message which has not been
	   fully read by rx_call(), rx_get_call() or rx_get_reply().
	   It should be used only by applications which cannot set limit
	   on the size of the received data.
	   On the return from this call the message will be put into the
	   buffer specified by cd->rmsg and the call returns the number
	   of bytes actually read (or -1 in case of error).
	*/

	register struct association *a;
	int i, len;

	struct inout_pkt *pk;

	TRACE(calls && fprintf(stderr, "rx_more(): ") && print_cd(cd));

	/* search the association in the active list */
	for (a = (struct association *)RXHEAD; (char *)a != NULL &&
		(a->addr_peer.host != cd->host || a->addr_peer.port != cd->port
		|| cd->call_number != a->call_number);
		a = (struct association *)a->link);

	if ((char *) a == NULL) {
		/* not found, return an error */
		RETURNERR(EBADCALLN, ETRX, "bad call no or addr")
	}
	/*
	   When we arrive here we should find the following situation:
	   a->readp points at the data to read in the packet. If this is
	   user code implementation, then the whole message has been
	   already queued. For kernel implementation we might be waken
	   up because of space problems in the kernel, so we have to wait
	   until the message is complete or the buffer is full.
	*/
	if ((char *)(pk = (struct inout_pkt *)a->in_pkts.head) == NULL) {
		/* caller does not know what (s)he is doing */
		a->readp = NULL;

		RETURNERR(EBADLEN, ETRX, "rx_more() receive queue is empty")
	}
	a->rmsg = cd->rmsg;
	a->rlen = cd->rlen;

	/* read packets which have been queued in user space */
	if (a->rlen < pk->len) {
		/* only part of packet fits in */
		bcopy(a->readp, a->rmsg, a->rlen);
		a->readp += a->rlen;
		pk->len -= a->rlen;
		return(a->rlen);
	} else {
		/* copy the whole packet and free it */
		bcopy(a->readp, a->rmsg, pk->len);
		a->rmsg += pk->len;
		a->rlen -= pk->len;
		a->readp = NULL;
		rx_free_packet(q_rhead(&a->in_pkts));
	}
	while ((char *)(pk = (struct inout_pkt *)a->in_pkts.head) != NULL) {
		if (a->rlen < pk->len) {
			/* only part of packet fits in */
			bcopy(pk->data + sizeof(struct rx_hdr), a->rmsg, a->rlen);
			a->readp = pk->data + sizeof(struct rx_hdr) + a->rlen;
			pk->len -= a->rlen;
			return(cd->rlen); /* we have read as much as requested */
		} else {
			/* copy the whole packet and free it */
			bcopy(pk->data + sizeof(struct rx_hdr), a->rmsg, pk->len);
			a->rmsg += pk->len;
			a->rlen -= pk->len;
			rx_free_packet(q_rhead(&a->in_pkts));
		}
	}
	a->readp = NULL;
	return(cd->rlen - a->rlen);
}
