/*
 * Debug and miscellaneous utilities.
 * CS - 07.09.2000 : general heavy clenaup
 *                   removed all old dead code: RX_KERNEL etc...
 */
#include "allincl.h"

#ifdef DEBUG
extern struct rx_glob rx_glob;

/*
  Sets the global call number. sometimes necessary in client/servers which
  are both at the same time.
*/

void
rx_setcalln(long int calln)
{
        rx_glob.call_number = calln;
}

rx_trace(char *flag_string)
{
	register char *cp;
	struct trace *trace;

	trace = &rx_glob.trace;
	trace->tron = trace->interrupts = trace->timers = trace->assoc =
		trace->packets = trace->allocation = trace->exceptions =
		trace->calls = 0;

	if ((flag_string != (char *)0) && (flag_string != "\0")) {
		trace->tron = 1;
		for (cp = flag_string; *cp != 0; cp += 1) {
			switch (*cp) {
			    case '?':
				printf("rx trace options:\n\
i\tinterrupts\n\
t\ttimers\n\
s\tassociations\n\
p\tpackets\n\
a\tallocation\n\
x\texceptions\n\
c\tcalls\n\
S\tstatistics\n\
\tempty string will switch off trace\n");
				break;
			    case 'i':
				trace->interrupts = 1;
				break;
			    case 't':
				trace->timers = 1;
				break;
			    case 's':
				trace->assoc = 1;

#if !defined(OS9)
				/* in OS9 print should not be called from the normal and interrupt contex */
				rx_dbg();
#endif

				break;
			    case 'p':
				trace->packets = 1;
				break;
			    case 'a':
				trace->allocation = 1;
				break;
			    case 'x':
				trace->exceptions = 1;
				break;
                            case 'S':
				rx_statistics();
                                break;
			    case 'c':
				trace->calls = 1;
				break;
			    default:
				break;
			}
		}
	}
}


char * print_ipaddr(struct addr *paddr)
{

   union {
	   long l;
	   char c[4];
	   } foo;

   static char buf[23];

   foo.l = paddr->host;
   sprintf(buf, "%d.%d.%d.%d.%d", foo.c[0] & 0xff, foo.c[1] & 0xff,
	   foo.c[2] & 0xff, foo.c[3] & 0xff,
	   (unsigned short)ntohs(paddr->port));
   return(buf);
}


print_cd(struct rx_call_descr *cd)
{

	fprintf(stderr, "%lx %x %lx %lx %d %d %ld\n",
		cd->call_number, cd->flags, (long)cd->smsg, (long)cd->rmsg, cd->slen, cd->rlen,
		cd->timeout);
}


#else /* DEBUG */
rx_trace(char *flag_string)
{
/* dummy for applications which want use debug */
}
char * print_ipaddr(struct addr *paddr)
{
	return("not impl");
}
#endif /*DEBUG */


void
rx_statistics()
{
struct rx_stats *s;
	s = &rx_stats;
	fprintf(stderr, "send:\t data %d\tcntrl snd %d\n",s->d_snd, s->c_snd);
	fprintf(stderr, "recv:\t %d\tcntrl rcv %d\tno ass %d\n\n",
		s->cd_rcv + s->rd_rcv, s->ca_rcv + s->ra_rcv, s->dr_ass);
	fprintf(stderr, "drop:\t         type %d\tsequence %d\tcallno %d\n",
		s->dr_typ, s->dr_seq, s->dr_callno);
	fprintf(stderr, "retransmissions: requested %d\treceived %d\n",
		s->retr_snd, s->retr_rcv);
}


char *
rxerror(int errcode)
{
	static char defaultmessage[20];

	/* Switch on the error number to find the corresponding string. */
	switch( errcode ) {

	    case ETOSERV:
		return( "timeout on message transmission");
	    case ETOREPL:
		return( "timeout on reply for acknowledged call");
	    case EPENDING:
		return( "too many asynch calls pending");
	    case EBADCALLN:
		return( "invalid call number filled in call descriptor");
	    case EINITIALIZ:
		return( "RX already initialised");
	    case ENOPEER:
		return( "no RX association at the remote port");
	    case ENOADDR:
		return( "no RX port at the remote IP address");
	    case ERX:
		return( "unexpected behavior of RX");
	    case EBADLEN:
		return( "bad length of send or receive data");
	    case EBADUSE:
		return( "bad use of RX protocol");
	    case ETORCV:
		return( "timeout on receiving (kernel only)");
	    case ENAMERES:
		return( "host not found or no access to nameserver");

		/* Default system error.                                */

	    default:
		sprintf( defaultmessage, "%s %d", "Error code", errcode );
		return( defaultmessage );

	}
}

void rx_gettmo(int *retr, int* tmo)
{
	*retr = rx.retransmissions;
	*tmo = rx.retr_tmo;
}

int rx_settmo(int retr, int tmo)
{
	if (retr > 4 || retr < 0 || tmo < 10 || tmo > 4000)
		return(-1);
	rx.retransmissions = retr;
	rx.retr_tmo = tmo;
	return(0);
}
