/*
 * First written by Kris Kostro 18 March 1991
 *
 *
 * usage: nh {hostnames}
 */
#include <ncc.h>
#include <stdio.h>
#define MXH 10

main(argc, argv)
	int argc;
	char **argv;
{
	char *input_string, *malloc();
	char *reverse_string_pointer=0;
	extern char *reverse_string_recv();
	int sid[MXH];
	char *hosts[MXH];
	long callid[MXH];
	int i, maxhost, id, replycnt, failed;

	if (argc < 2) {
		fprintf(stderr, "Usage: %s {up to %d hostnames}\n", argv[0], MXH);
		exit(1);
	}


	nc_trace("mrdec");
	input_string = malloc(100);     /* we cannot dereference an array */

	for (i = 0; (i < MXH) && (i < argc - 1); i ++) {
		hosts[i] = argv[i+1];
		printf("importing nh service on host %s\n", hosts[i]);
		if ((sid[i] = import_nh(hosts[i])) < 0 ) {
			nc_perror("import_nh()");
			exit( 1 );
		}
	}
	maxhost = i;

	do {
		printf("enter string:    ");
		for( ; gets(input_string) == (char *)0 ; );
		failed = 0;
		for (i = 0; i < maxhost; i++) {
			bind_nh(sid[i]);
			printf("sending string %s to host %s\n", input_string, hosts[i]);
			if(reverse_string_cl_send(&input_string) == -1) {
				nc_perror(hosts[i]);
				/*
				 * We could also mark this sid as "broken"
				 * to avoid repeating send the next time we pass here.
				 */
				failed ++;
			}
		}
#ifdef SILLY
		/* This is the way asynchronous RPC was used in version 1. It still works... */
		for (i = 0; i < maxhost; i++) {
			bind_nh(sid[i]);
			printf("from host %s ", hosts[i]);
			if(reverse_string_cl_recv(&reverse_string_pointer) == -1)
				nc_perror(argv[0]);
			else
				printf("reversed string: %s\n", reverse_string_pointer );
		}
#else
		/* receive all requests */
		replycnt = 0;
		maxhost -= failed;
		do {
			id = nc_wait_reply(0, NC_P_RX, 20);
			if (id < 0) {
				nc_perror(argv[0]);
				exit(1);
			}
			if (id == 0) {
				/* timeout, break the loop */
				printf("timed out after %d replies\n", replycnt);
				break;
			}

			/* find the correspondance between id and index */
			for (i = 0; i < MXH && callid[i] != id; i++) ;
			if (i == MXH) {
				printf("invalid call id %d returned by nc_wait_reply()\n", id);
				exit(1);
			}
			bind_nh(sid[i]);
			printf("from host %s ", hosts[i]);
			if(reverse_string_cl_recv(reverse_string_pointer) == -1)
				nc_perror(argv[0]);
			else
				printf("reversed string: %s\n", reverse_string_pointer );

			replycnt ++;
		} while (replycnt < maxhost);
		maxhost += failed;
#endif
	} while (reverse_string_pointer != 0);
	for (i = 0; i < maxhost; i++)
		free_nh(sid[i]);
}
