#include <stdio.h>
#include <ncc.h>

int sleeptime;
char *input_string, *malloc();
char *output_string, *reverse_string();

main( argc, argv )
	int argc;
	char **argv;
{
	int sid, status;

	if (argc > 4) {
		fprintf(stderr, "Usage: %s machine [sleeptime [nc traceflags rx traceflags]]\n", argv[0]);
		exit(1);
	}

	if (argc >= 2)
		sleeptime = (atoi(argv[1]));
	else
		sleeptime = 0;

	if (argc >= 3)
		nc_trace(argv[2]);
	if (argc >= 4)
		rx_trace(argv[3]);

	if( (sid = export_nh()) < 0 ) {
		nc_perror("export_nh()");
		exit( 1 );
	}

	for (;;) {
		if (reverse_string_sr_recv(&input_string) == -1)
			nc_perror(argv[0]);
		else
			printf("%s received string: %s\n", argv[0], input_string );
		output_string = reverse_string(input_string);
		nc_deallocate(input_string);
		if (reverse_string_sr_send(&output_string) == -1)
			nc_perror(argv[0]);
		else
			printf("%s sent string: %s\n", argv[0], output_string );
	}
}


