/*
 *	svt_nc.h
 */
    

/* Computer architecture constants -
 * Use include file <limits.h> where available,
 * and when it conforms to IEEE-Std. 1003 POSIX.
 */
              
#ifdef NONE 
#include <limits.h>
#define MOCT         SCHAR_MAX
#define MUOCT        UCHAR_MAX
#define MSHRT        SHRT_MAX
#define MUSHRT       USHRT_MAX
#define MLONG        LONG_MAX
#define MULONG       ULONG_MAX
#else
#define MOCT         127
#define MUOCT        255
#define MSHRT        32767
#define MUSHRT       65535
#define MLONG        2147483647
#define MULONG       4294967295
#endif

#define SERVICE      svt
#define SERVICE_NAME "svt"  
#define IMPORT       import_svt
#define IMPORT_NAME  "import_svt" 
#define EXPORT       export_svt 
#define EXPORT_NAME  "export_svt"
                          
#define PORT         1807
 
#define VERSION      2.0
 
#define FALSE        0
#define TRUE         1

/* No swap patterns - */  
#define USSPI        (0x1234)
#define UMSPI        USSPI
#define ULSPI        (0x12345678) 

/* IEEE Std.754 specifies the following precision and range:
 *
 *                    Significant     Decimal
 *                   decimal digits    range
 * single precision      7 - 8        10**38
 * double precision     15 - 16       10**308
 *
 * Hence the following test limits on float and double transfers.
 */ 

#define  DDIFF_LIMIT    ((double)1.e-16) 
#define  FDIFF_LIMIT    ((double)1.e-8) 

/* A float/double patterns */
#define FNUMB   3.14159265358979323846  /* this is M_PI from math.h */
#define DNUMB   3.14159265358979323846  /* this is M_PI from math.h */


