/* %W% %E% */
/*
 * Origin       Eric Cooper UCB
 *
 * 26.06.90 kk  Three types of signal interface are defined:
 *              BSDsignal (sigvec() etc.) SYSV3signal (sigset() etc.)
 *              and SYSVsignal (only rudimentary signal())
 *              All systems should define one of the three
 *              Two types of time interface are used: BSDtime (gettimeofday())
 *              and SYSVtime (time()).
 *
 * LP - 23.05.2000 - correct cast of signal handler function in signal()
 *                   call.
 * CS - 05.09.2000 - adeguato prototipo tm_clockinterrupt per essere conforme
 *                   alle specifiche di signal (2)
 * CS - 11.09.2000 - rimosso #ifdef obsoleto
 */


#if defined(SYSV3signal) || defined(SYSVsignal)
#include <signal.h>
#endif

#include "tm_include.h"

/*
 * Handle a clock interrupt. Call action routines for all timers
 * that have expired. Rearm interval timer for the next deadline.
 */
/*int tm_clockinterrupt(void)*/
void tm_clockinterrupt(int sig) /* CS - 05.09.2000 */
{
	register struct timer *t;
	struct timeval now;
	int status = 0;

#if defined(SYSV3signal)
	sigset(SIGALRM, tm_interrupt);
#endif

#if defined(SYSVsignal)
	/*signal(SIGALRM, (void *)tm_interrupt);*/
	signal(SIGALRM, tm_interrupt);
#endif

	TRACE(tm_traceinterrupts && \
	      tm_printinterrupt("tm_clockinterrupt", 1));
	TRACE(tm_tracetimers && tm_printtimers("tm_clockinterrupt"));
	for (;;) {
		if ((t = (struct timer *) tm_queue.head) == ZERO)
			break;

		tm_now(&now);
		if (tm_compare(&now, &t->deadline) < 0) {
			tm_startclock(&now, &t->deadline);
			break;
		}
		q_rhead(&tm_queue);
		status = (*(t->action))(t);
	}

	TRACE(tm_traceinterrupts && tm_printinterrupt("tm_clockinterrupt", 0));

	/* Return the status to the caller.                             */
	/*return( status );*/
	return; /* CS - 05.09.2000 */
}
