/* %W% %E% */
/*
 * Creation 1983 by J. Cooper, UCB
 *
 * 21/05/90 raw: Added dummy function tm_traceinit;
 *               make tracing flags switchable with "+" and "-"
 */

#include "tm_include.h"

/*
 * Global variables maintained by the tracing routine. Flags
 * indicating which tracing is enabled.
 */

int     tm_tracingon = 0;                       /* Tracing enabled */
int     tm_traceinterrupts = 0;                 /* Trace interrupts */
int     tm_tracetimers = 0;                     /* Trace timers */

/*
 * A call to this dummy function makes the initializations of the tracing
 * variables visible to the program package.
 */
void
tm_traceinit(void)
{
}

/*
 * Set and reset the trace flags for the timer package.
 * A flag will be set by giving the corresponding letter in the flag
 * string. The letter can optionally be preceeded by a "+" (plus sign).
 * A flag will be reset (switched off) by giving the corresponding
 * letter preceeded by a "-" (minus sign).
 * Note that the flags are initialized to being off.
 */

tm_traceflags(char *flag_string)
{
	register char *cp;
	int value;

	tm_tracingon = 1;
	for (cp = flag_string; *cp != 0; cp += 1) {

		value=1;
		switch (*cp)
		{
		    case '-':
			value=0;
		    case '+':
			cp++;
		}

		switch (*cp) {
		    case 'i':
			tm_traceinterrupts = value;
			break;
		    case 't':
			tm_tracetimers = value;
			break;
		}
	}
}
